/**********************************/
/*																*/
/*							Znax							*/
/*																*/
/**********************************/

#include <PA9.h>   
#include "gfx/bloc.c"
#include "fond.h"
#include "gfx/all_gfx.c"
#include "gfx/all_gfx.h"
#include "son1.h"
#include "son2.h"

#define X_OFFSET  48
#define Y_OFFSET  10
#define ANIM_TIME 15
#define TIME_MAX  180

u8 grille[10][10];

struct {
	u8 i;
	u8 x[4],y[4];
	u8 color[4];
	u32 score;
	int time;
} player;

u16 bloc0,bloc1,bloc2,bloc3,pooof; //Adresse des gfx


u8 znax_ColorVerification(u8 n) {
	if(n == 0) if((player.color[n] != 36) && (player.color[0] == player.color[1] || player.color[0] == player.color[2] || player.color[0] == player.color[3])) return 1;
	if(n == 1) if((player.color[n] != 36) && (player.color[1] == player.color[0] || player.color[1] == player.color[2] || player.color[1] == player.color[3])) return 1;
	if(n == 2) if((player.color[n] != 36) && (player.color[2] == player.color[0] || player.color[2] == player.color[1] || player.color[2] == player.color[3])) return 1;
	if(n == 3) if((player.color[n] != 36) && (player.color[3] == player.color[0] || player.color[3] == player.color[2] || player.color[3] == player.color[1])) return 1;
	return 0;
}

u8 znax_VerificationX(u8 n) {
	if(n == 0) if(player.x[0] == player.x[1] || player.x[0] == player.x[2] || player.x[0] == player.x[3]) return 1;
	if(n == 1) if(player.x[1] == player.x[0] || player.x[1] == player.x[2] || player.x[1] == player.x[3]) return 1;
	if(n == 2) if(player.x[2] == player.x[0] || player.x[2] == player.x[1] || player.x[2] == player.x[3]) return 1;
	if(n == 3) if(player.x[3] == player.x[0] || player.x[3] == player.x[2] || player.x[3] == player.x[1]) return 1;
	return 0;
}

u8 znax_VerificationY(u8 n) {
	if(n == 0) if(player.y[0] == player.y[1] || player.y[0] == player.y[2] || player.y[0] == player.y[3]) return 1;
	if(n == 1) if(player.y[1] == player.y[0] || player.y[1] == player.y[2] || player.y[1] == player.y[3]) return 1;
	if(n == 2) if(player.y[2] == player.y[0] || player.y[2] == player.y[1] || player.y[2] == player.y[3]) return 1;
	if(n == 3) if(player.y[3] == player.y[0] || player.y[3] == player.y[2] || player.y[3] == player.y[1]) return 1;
	return 0;
}

u8 znax_AllVerification() {
	if(znax_VerificationX(0) && znax_VerificationX(1) && znax_VerificationX(2) && znax_VerificationX(3) 
		&& znax_VerificationY(0) && znax_VerificationY(1) && znax_VerificationY(2) && znax_VerificationY(3)
		&& znax_ColorVerification(0) && znax_ColorVerification(1) && znax_ColorVerification(2) && znax_ColorVerification(3)) {
			return 1;
		} else {
			return 0;
		}
}

void znax_ReDone(u8 x, u8 y, u8 width, u8 height) {
	int i,j;
	u8 cnt = 0; //compteur pour l'animation de victoire
	
	PA_SetSpriteY(0,0,192); PA_SetSpriteY(0,1,192);
	PA_SetSpriteY(0,2,192); PA_SetSpriteY(0,3,192);
	
	while(cnt++ < ANIM_TIME) {
		for(i=x;i<x+width;i++) {
			for(j=y;j<y+height;j++) {
				PA_CreateSpriteFromGfx(0,20+i+j*10,pooof,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
			}
		}
		PA_WaitForVBL();
	}
	
	for(i=x;i<x+width;i++) {
		for(j=y;j<y+height;j++) {
			grille[i][j] = PA_Rand()&3;
			if(grille[i][j] == 0) PA_CreateSpriteFromGfx(0,20+i+j*10,bloc0,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
			if(grille[i][j] == 1) PA_CreateSpriteFromGfx(0,20+i+j*10,bloc1,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
			if(grille[i][j] == 2) PA_CreateSpriteFromGfx(0,20+i+j*10,bloc2,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
			if(grille[i][j] == 3) PA_CreateSpriteFromGfx(0,20+i+j*10,bloc3,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
		}
	}
	
	player.color[0] = 36; 
	player.color[1] = 36;
	player.color[2] = 36;
	player.color[3] = 36;
	
	player.i = 0;
  
}

void znax_Init() {
	
	PA_Init8bitBg(0, 3);
	PA_LoadGif(	0,(void*)fond);
	
	while((PA_Rand()%64) != PA_RTC.Seconds) if(PA_Rand()%4+6 == 8); //On initialise la fonction rand, pour ne pas avoir le mme niveau  chaque fois
		
	PA_Init8bitBg(1, 0);
	PA_SetBgPalCol(1, 0, PA_RGB(31, 31, 31));
	PA_SetBgPalCol(1, 1, PA_RGB(0, 15, 25));
	PA_SetBgPalCol(1, 2, PA_RGB(0, 15, 25));
	PA_SetBgPalCol(1, 3, PA_RGB(31, 0, 0));
	
	PA_EasyBgLoad(1, 2, haut);	
	
	PA_SetBgPalCol(0, 80, PA_RGB(13, 17, 27));
	
	while(!Stylus.Newpress) {
		PA_CenterSmartText(0, 0, -17, 255, 120, "Click 4 tiles of the same color\n and form squares as big\n as you can.\n You will erase all the tiles \ninside the square and collect\n points.    \nTime is running...\n\nPlay!", 80, 2, 1);
		PA_WaitForVBL();
	}
	PA_WaitForVBL();
	PA_LoadGif(	0,(void*)fond);
	
	PA_LoadSpritePal(0,0,(void*)blocPal);
	bloc0 = PA_CreateGfx(0,(void*)blocTiles,OBJ_SIZE_16X16,1);
	bloc1 = PA_CreateGfx(0,(void*)(blocTiles+128),OBJ_SIZE_16X16,1);
	bloc2 = PA_CreateGfx(0,(void*)(blocTiles+256),OBJ_SIZE_16X16,1);
	bloc3 = PA_CreateGfx(0,(void*)(blocTiles+384),OBJ_SIZE_16X16,1);
	u16 selec = PA_CreateGfx(0,(void*)(blocTiles+512),OBJ_SIZE_16X16,1);
	pooof = PA_CreateGfx(0,(void*)(blocTiles+640),OBJ_SIZE_16X16,1);
	
	PA_CreateSpriteFromGfx(0,0,selec,OBJ_SIZE_16X16, 1, 0, 256, 192);
	PA_CreateSpriteFromGfx(0,1,selec,OBJ_SIZE_16X16, 1, 0, 256, 192);
	PA_CreateSpriteFromGfx(0,2,selec,OBJ_SIZE_16X16, 1, 0, 256, 192);
	PA_CreateSpriteFromGfx(0,3,selec,OBJ_SIZE_16X16, 1, 0, 256, 192);
	
	int i,j;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			grille[i][j] = PA_Rand()&3;
			if(grille[i][j] == 0) PA_CreateSpriteFromGfx(0,20+i+j*10,bloc0,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
			if(grille[i][j] == 1) PA_CreateSpriteFromGfx(0,20+i+j*10,bloc1,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
			if(grille[i][j] == 2) PA_CreateSpriteFromGfx(0,20+i+j*10,bloc2,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
			if(grille[i][j] == 3) PA_CreateSpriteFromGfx(0,20+i+j*10,bloc3,OBJ_SIZE_16X16, 1, 0, X_OFFSET + i*16, Y_OFFSET + j*16);
		}
	}
	player.color[0] = 36;
	player.color[1] = 36;
	player.color[2] = 36;
	player.color[3] = 36;
	player.i = 0;
	player.time = 0;
	player.score = 0;
	
}


//Algorythme provenant de http://linux.wku.edu/~lamonml/algor/sort/quick.html

void q_sort(u8 numbers[], int left, int right)
{
  int pivot, l_hold, r_hold;

  l_hold = left;
  r_hold = right;
  pivot = numbers[left];
  while (left < right)
  {
    while ((numbers[right] >= pivot) && (left < right))
      right--;
    if (left != right)
    {
      numbers[left] = numbers[right];
      left++;
    }
    while ((numbers[left] <= pivot) && (left < right))
      left++;
    if (left != right)
    {
      numbers[right] = numbers[left];
      right--;
    }
  }
  numbers[left] = pivot;
  pivot = left;
  left = l_hold;
  right = r_hold;
  if (left < pivot)
    q_sort(numbers, left, pivot-1);
  if (right > pivot)
    q_sort(numbers, pivot+1, right);
}

void znax_quickSort(u8 numbers[], int array_size)
{
  q_sort(numbers, 0, array_size - 1);
}

void PA_Sleep(int s) {
	int i = 0;
	while(i++ < s*60) {
		PA_WaitForVBL();
	}
}



int main(int argc, char ** argv)
{
	PA_Init();    // Initializes PA_Lib
	PA_InitVBL(); // Initializes a standard VBL
	PA_InitSound();
	PA_SetBgPalCol(0, 0, PA_RGB(31, 31, 31));
	
	debut: 
	
	
	znax_Init();
	
	int i,j;
	
	char *tmp = "00000000";
	char *str = "                  ";
	
	while(1) {
		//PA_Clear8bitBg(1); 
		DMA_Copy(0, (void*)(PA_DrawBg[1])+73*256, 256*32, DMA_16NOW);
		sprintf(tmp,"%08d",player.score);
		
		PA_CenterSmartText(1, 0, 40, 255, 120, tmp, 1, 4, 1);
		
		sprintf(str,"Time left : %d",TIME_MAX - (player.time/60));
		PA_CenterSmartText(1, 0, 120, 255, 120, str, 1, 3, 1);
		
		if(TIME_MAX - (player.time/60) == 0) {
			PA_CenterSmartText(1, 0, 70, 255, 120, "Time Over!", 3, 3, 1);
			PA_Sleep(3);
		}
		while(TIME_MAX - (player.time/60) == 0) {
			PA_SetSpriteY(0,0,192); PA_SetSpriteY(0,1,192);
			PA_SetSpriteY(0,2,192); PA_SetSpriteY(0,3,192);
			
			sprintf(tmp,"%08d",player.score);
			
			PA_CenterSmartText(1, 0, 40, 255, 120, tmp, 1, 4, 1);
		
			sprintf(str,"Time left : %d",TIME_MAX - (player.time/60));
			PA_CenterSmartText(1, 0, 120, 255, 120, str, 1, 3, 1);
			
			PA_CenterSmartText(1, 0, 70, 255, 120, "Time Over!", 3, 3, 1);
				
			if(Stylus.Newpress) {
				for(i=0;i<10;i++) {
					for(j=0;j<10;j++) {
							PA_SetSpriteXY(0,20+i+j*10,256,192);
					}
				}
				goto debut;
			}
			PA_WaitForVBL();
		}
		
		
		if(Stylus.Newpress && Stylus.X+2 <= (X_OFFSET+16*10) && Stylus.X >= X_OFFSET && Stylus.Y+2 <= (Y_OFFSET+16*10) && Stylus.Y >= Y_OFFSET) {
			if(player.i == 4) player.i = 0;
			
			player.x[player.i] = ((Stylus.X)>>4)-3;
			player.y[player.i] = ((Stylus.Y-8)>>4);
			if(player.i == 0 || player.x[player.i] != player.x[player.i-1] || player.y[player.i] != player.y[player.i-1]) {
				PA_SetSpriteXY(0,player.i, X_OFFSET + player.x[player.i]*16, Y_OFFSET + player.y[player.i]*16);
				player.color[player.i] = grille[player.x[player.i]][player.y[player.i]];
				player.i++;
				PA_PlaySimpleSound(0, son1);
			}
			
		}
		
		if(player.i == 2) {
			if(znax_VerificationX(0) || znax_VerificationY(0)) {
				//PA_OutputSimpleText(1, 0, 1, "Continue!");
			}
		} else {
			
		}
		
		if(player.i == 3) {
			if(((znax_VerificationX(1) && znax_VerificationY(1)) 
				|| (znax_VerificationX(2) && znax_VerificationY(2))
				|| (znax_VerificationX(3) && znax_VerificationY(3))
				|| (znax_VerificationX(0) && znax_VerificationY(0))) 
				&& znax_ColorVerification(0) 
				&& znax_ColorVerification(1) 
				&& znax_ColorVerification(2) ) {
				//PA_OutputSimpleText(1, 0, 2, "Continue!");
			} else {
				player.i = 0;
				PA_SetSpriteY(0,0,192); PA_SetSpriteY(0,1,192);
				PA_SetSpriteY(0,2,192); PA_SetSpriteY(0,3,192);
				
			}
		}
		
		
		if(player.i == 4) {
			if(znax_AllVerification()) { 
				PA_PlaySimpleSound(1, son2);
				//On range les x et y :)
				znax_quickSort(player.x,4);
				znax_quickSort(player.y,4);
				znax_ReDone(player.x[0],player.y[0],player.x[3]-player.x[0]+1,player.y[3]-player.y[0]+1);
				player.score += (player.x[3]-player.x[0])*(player.y[3]-player.y[0])*11; //On ajoute la surface au score ^^
				
			}	else { 
				player.i = 0;
				PA_SetSpriteY(0,0,192); PA_SetSpriteY(0,1,192);
				PA_SetSpriteY(0,2,192); PA_SetSpriteY(0,3,192);
			}
		}
		
		
		
		
		player.time++;
		PA_WaitForVBL();
	}
	
	return 0;
}

